<template>
  <div
    class="px-10 rounded-lg provider-tooltip"
    :class="[
      isGameProviderToolTipVisible === true && 'isProviderVisible',
      isProviderMoreThanThree ? 'w-full' : 'tooltip-translate',
      { 'px-2': isMobile },
    ]"
    @mouseenter="$emit('openToolTip', 'Provider')"
    @mouseleave="$emit('closeToolTip', 'Provider')"
  >
    <div
      :class="[
        isProviderMoreThanThree ? 'grid' : 'flex flex-nowrap',
        gridColumn,
      ]"
      class="py-4"
    >
    <div
        v-for="(providerMenus, index) in getProviderItems"
        :key="index"
        class="provider-group"
      >
        <div
          v-for="(dropdown, i) in providerMenus"
          :key="i"
          :class="`drop-down-list ${dropdown.IsActive ? 'active' : ''} ${
            dropdown.IsMaintain
            ? 'opacity-[0.4] pointer-events-none grayscale-[1]'
            : ''
        }`"
        >
          <div
            class="flex items-center justify-between gap-2 cursor-pointer grid-item py-2 px-3"
            :class="!dropdown.IsActive && 'dropdown-btn'"
            @click="
              () => [
                $emit('dropDownClick', dropdown),
                $emit('closeToolTip', 'Provider'),
              ]
            "
          >
            <div class="relative flex items-center">
              <img
                :class="dropdown.IsActive && 'active'"
                class="drop-down-icon btn__logo"
                :src="dropdown.DropDownLogoActivePath"
              />
              <div v-if="dropdown.IsMaintain" class="absolute top-[1px]">
                <img
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/icon_maintainance.png'
                    )
                  "
                />
              </div>
              <span
                :class="`${
                  dropdown.IsActive ? 'fc-primary' : 'whitespace-nowrap'
                } px-2 !ml-0 provider-label truncate`"
              >
                {{ dropdown.GameProviderDisplayName }}
              </span>
            </div>
            <div class="flex items-center">
              <span v-if="dropdown.IsNew" class="is-new">
                <img
                  :src="getAssetImage('assets/theme/common/icon/new_icon.svg')"
                />
              </span>
              <span v-if="dropdown.IsHot && !dropdown.IsNew" class="is-new">
                <img
                  :src="getAssetImage('assets/theme/common/icon/hot_icon.svg')"
                />
              </span>
              <span v-if="dropdown.IsPromotion" class="is-promotion">{{
                isPromotionText
              }}</span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script setup lang="ts">
import _ from "lodash-es";
import { GameEntryMenu, TabGameDropDownMenus } from "@/models/gameEntryFilter";
const { getAssetImage } = commonHelper;

const emits = defineEmits(["openToolTip", "closeToolTip", "dropDownClick"]);
const props = defineProps({
  toolTipXLocation: {
    type: String,
    default: "0px",
  },
  isPromotionText: {
    type: String,
    default: "Promo",
  },
  gameMenuForDisplay: {
    type: Array as PropType<GameEntryMenu[]>,
    required: true,
  },
  isGameProviderToolTipVisible: {
    type: Boolean,
    default: false,
  },
});
const isMobile = !useIsDesktop();
const gridColumn = computed(() => (isMobile ? "grid-cols-2" : "grid-cols-4"));
const providerItems = computed(() => props?.gameMenuForDisplay[0].Menus.find((item) => item.Label.toLowerCase() === 'provider'));
const isProviderMoreThanThree = computed(() => providerItems.value?.DropDownMenus?.length > 3);
const getProviderItems = computed(() => {
  let items = providerItems.value?.DropDownMenus;
  items = _.orderBy(_.orderBy(items, "DropDownLabel"), "displayOrder");
  // eslint-disable-next-line array-callback-return
  let providerList = (isMobile ? [0, 1] : [0, 1, 2, 3]).map((page) => {
    const assignArr: TabGameDropDownMenus[] = [];
    items?.forEach((item, index) => {
      if (index % (isMobile ? 2 : 4) === page) assignArr.push(item);
    });
    return assignArr;
  });
  providerList = providerList.filter((arr) => arr.length > 0);
  return providerList;
});
</script>
<style lang="scss">
.provider-tooltip {
  position: absolute;
  top: 0;
  left: 0;
  --extraTranslateY: 0px;
  transform: translateY(calc(53px + var(--extraTranslateY)));
  z-index: 30;
  opacity: 0;
  transition: opacity 200ms ease-out;
  --L1350: linear-gradient(rgba(0, 0, 0, 0.35), rgba(0, 0, 0, 0.35)), linear-gradient(var(--background5), var(--background5));
  background: var(--L1350);
  pointer-events: none;
  &.tooltip-translate {
    transform: translate(calc(v-bind(toolTipXLocation) - 50%), calc(53px + var(--extraTranslateY)));
  }
  .active .btn__logo {
    filter: var(--primary-filter);
  }
  .drop-down-list:hover span {
    color: var(--textBtn);
    font-weight: 500;
  }
  div.drop-down-list {
    padding: 0px;
  }
  .dropdown-btn:hover {
    background-color: var(--primary);
  }
  .provider-group + .provider-group {
    border-left: 1px solid var(--border);
  }
  .drop-down-list .is-new {
    background: transparent;
    padding: 0;
    img {
      height: 16px;
      width: 48px;
    }
  }
  .active .provider-label {
    font-weight: 500;
  }
  .provider-label {
    color: var(--text5);
    &.fc-primary {
      color: var(--primary);
    }
  }
  .drop-down-icon {
    filter: var(--text5-filter);
  }
}
.blue-customize {
  .provider-tooltip {
    .provider-label {
      color: var(--text);
      font-weight: 500;
    }
    .grid {
      margin-bottom: 0;
      .provider-label.fc-primary {
        color: var(--primary);
        font-weight: 500;
      }
      .flex.dropdown-btn:hover .flex span {
        color: var(--textBtn);
      }
      .flex .flex .provider-label {
        color: var(--text5);
        &.fc-primary {
          color: var(--primary);
        }
      }
    }
  }
}
.black-flexible1-customize {
  .provider-tooltip {
    .grid {
      margin-bottom: 0;
      .flex .flex .provider-label {
        color: var(--text5);
        &.fc-primary {
          color: var(--primary);
        }
      }
    }
  }
}
.black-flexible1-customize .provider-tooltip .grid .flex .flex span {
  color: var(--text5);
}
.provider-tooltip.isProviderVisible {
  opacity: 1;
  pointer-events: unset;
}
[theme-color="peru_green"] .provider-tooltip {
  --extraTranslateY: 3px;
}
</style>
